{ pkgs ? import <nixpkgs> { } }:

with pkgs;

let
  mycsfml = csfml.overrideAttrs (oldAttrs: rec {
    src = fetchFromGitHub {
      owner = "lafeychine";
      repo  = "CSFML";
      rev   = "b3092f4e032092563f9f55129eddf7ca95b12a59";
      sha256 = "sha256-bEba6uU/qiL9AcomiablcdvECpp3SgYGcsIL8lyLU2I=";
    };
  });
  llvmPackages = llvmPackages_13;
  stdenv = llvmPackages.libcxxStdenv;
in stdenv.mkDerivation (rec {
  name = "prog-2";
  buildInputs = [ mycsfml llvmPackages.lld sbt which ];
  LD_LIBRARY_PATH =
    lib.makeLibraryPath [ mycsfml llvmPackages.libcxx llvmPackages.libcxxabi ];
})
