package Main

import SFML.Graphics.{Color, RenderWindow}
import SFML.Window.{VideoMode, Window}

val FRAMERATE = 30

@main def main() =
    val videoMode = VideoMode(1024, 768, 32)
    val window = RenderWindow(videoMode, "Projet", Window.WindowStyle.DefaultStyle)

    window.setFramerateLimit(FRAMERATE)
    window.setVerticalSyncEnabled(true)

    val game = Game(window, Scene.Battle.BattleScene)

    while window.isOpen() do
        window.clear(Color(0, 0, 0, 0))

        game.fetchEvents()
        game.currentScene.components.foreach(_.update(game))
        game.currentScene.components.foreach(_.draw(window))

        window.display()
