package Component

import SFML.Graphics.IntRect

import Component.*

trait Button(size_x: Int, size_y: Int) extends DrawableTexture:
    var isHovering = false

    def onMouseOver(game: Main.Game): Unit
    def onMouseClick(game: Main.Game): Unit
    def onMouseExit(game: Main.Game): Unit

    def init(): Unit = ()

    def update(game: Main.Game): Unit =
        val oldHovering = isHovering
        val rect = IntRect(pos._1.toInt, pos._2.toInt, size_x * scale, size_y * scale)

        isHovering = rect.contains(game.mouse._1, game.mouse._2)

        if !oldHovering && isHovering then onMouseOver(game)
        if oldHovering && !isHovering then onMouseExit(game)
        if isHovering && game.mouseButtonClicked then onMouseClick(game)
