package Component

import SFML.Graphics.{Color, IntRect, RenderWindow, Sprite, Texture}
import SFML.System.Vector2f

trait DrawableTexture(texture: Texture) extends Drawable:
    var rect: Option[(Int, Int)] = None

    def draw(window: RenderWindow) =
        val sprite = Sprite(texture)

        rect match
            case None       => ()
            case Some(rect) => sprite.setTextureRect(IntRect(0, 0, rect._1, rect._2))

        sprite.setPosition(Vector2f(pos._1, pos._2))
        sprite.setScale(Vector2f(scale, scale))
        sprite.setColor(Color(color, color, color, 255.toByte))
        window.draw(sprite)
