package Pokemon

object CapacityFactory:

    private case class Absorb() extends Capacity("Absorb", Grass, 25, 25, 20)
    private case class Bubble() extends Capacity("Bubble", Water, 30, 30, 40)
    private case class BubbleBeam() extends Capacity("Bubble Beam", Water, 20, 20, 65)
    private case class Constrict() extends Capacity("Constrict", Normal, 35, 35, 10)
    private case class Ember() extends Capacity("Ember", Fire, 25, 25, 40)
    private case class FireSpin() extends Capacity("Fire Spin", Fire, 15, 15, 35)
    private case class RockThrow() extends Capacity("Rock Throw", Rock, 15, 15, 50)
    private case class Thunder() extends Capacity("Thunder", Electric, 10, 10, 110)
    private case class VineWhip() extends Capacity("Vine Whip", Grass, 25, 25, 45)

    def apply(name: String): Capacity = name match
        case "Absorb"      => Absorb()
        case "Bubble"      => Bubble()
        case "Bubble Beam" => BubbleBeam()
        case "Constrict"   => Constrict()
        case "Ember"       => Ember()
        case "Fire Spin"   => FireSpin()
        case "Rock Throw"  => RockThrow()
        case "Thunder"     => Thunder()
        case "Vine Whip"   => VineWhip()
