package Pokemon

sealed trait Type(val strong_on: List[Type], val weak_on: List[Type], val inefficient_on: List[Type]):
    def typeEfficiency(ptype: Type): Efficiency =
        if strong_on.contains(ptype) then Efficient
        else if weak_on.contains(ptype) then NotEfficient
        else if inefficient_on.contains(ptype) then Inefficient
        else Neutral

case object Normal extends Type(List(), List(Rock), List(Ghost))
case object Fight extends Type(List(Normal, Rock, Ice), List(Poison, Flying, Bug, Psychic), List(Ghost))
case object Flying extends Type(List(Bug, Fight, Grass), List(Electric, Rock), List())
case object Poison extends Type(List(Bug, Grass), List(Poison, Ground, Rock, Ghost), List())
case object Ground extends Type(List(Electric, Fire, Poison, Rock), List(Bug, Grass), List(Flying))
case object Rock extends Type(List(Bug, Fire, Flying, Ice), List(Fight, Ground), List())
case object Bug extends Type(List(Grass, Poison, Psychic), List(Fight, Fire, Flying, Ghost), List())
case object Ghost extends Type(List(Ghost), List(), List(Normal, Psychic))
case object Fire extends Type(List(Bug, Grass, Ice), List(Dragon, Fire, Rock, Water), List())
case object Water extends Type(List(Fire, Ground, Rock), List(Dragon, Grass, Water), List())
case object Grass extends Type(List(Ground, Rock, Water), List(Bug, Dragon, Fire, Flying, Grass, Poison), List())
case object Electric extends Type(List(Flying, Water), List(Dragon, Electric, Grass), List(Ground))
case object Psychic extends Type(List(Fight, Poison), List(Psychic), List())
case object Ice extends Type(List(Dragon, Flying, Grass, Ground), List(Ice, Water), List())
case object Dragon extends Type(List(Dragon), List(), List())
