package Scene.Battle.CapacitySelector

import Component.*
import Pokemon.*
import Scene.*

import SFML.Graphics.{Font, IntRect, Texture}

object CapacitySelectorScene extends Scene:
    def load(game: Main.Game) =
        val pokemonTrainer = game.trainer.primaryPokemon.get

        val background = Sprite(Texture("src/main/resources/battle/background_capacities.png"))
        background.scale = 4
        this.addComponent(background)

        val capacity_texture = Texture("src/main/resources/battle/capacity.png")
        val font = Font("src/main/resources/font.ttf")

        if pokemonTrainer.capacity.length >= 1 then
            val capacity_1 = CapacityBox(capacity_texture, pokemonTrainer.capacity(0))
            capacity_1.scale = 4
            capacity_1.pos = (8, 24)
            this.addComponent(capacity_1)

            val capacity_text_1 = Text(font)
            capacity_text_1.msg = pokemonTrainer.capacity(0).name
            capacity_text_1.color = 0.toByte
            capacity_text_1.pos = (68, 84)
            this.addComponent(capacity_text_1)

        if pokemonTrainer.capacity.length >= 2 then
            val capacity_2 = CapacityBox(capacity_texture, pokemonTrainer.capacity(1))
            capacity_2.scale = 4
            capacity_2.pos = (520, 24)
            this.addComponent(capacity_2)

            val capacity_text_2 = Text(font)
            capacity_text_2.msg = pokemonTrainer.capacity(1).name
            capacity_text_2.color = 0.toByte
            capacity_text_2.pos = (580, 84)
            this.addComponent(capacity_text_2)

        if pokemonTrainer.capacity.length >= 3 then
            val capacity_3 = CapacityBox(capacity_texture, pokemonTrainer.capacity(2))
            capacity_3.scale = 4
            capacity_3.pos = (8, 268)
            this.addComponent(capacity_3)

            val capacity_text_3 = Text(font)
            capacity_text_3.msg = pokemonTrainer.capacity(2).name
            capacity_text_3.color = 0.toByte
            capacity_text_3.pos = (68, 328)
            this.addComponent(capacity_text_3)

        if pokemonTrainer.capacity.length >= 4 then
            val capacity_4 = CapacityBox(capacity_texture, pokemonTrainer.capacity(3))
            capacity_4.scale = 4
            capacity_4.pos = (520, 268)
            this.addComponent(capacity_4)

            val capacity_text_4 = Text(font)
            capacity_text_4.msg = pokemonTrainer.capacity(3).name
            capacity_text_4.color = 0.toByte
            capacity_text_4.pos = (580, 328)
            this.addComponent(capacity_text_4)

        val cancel = CancelBox(Texture("src/main/resources/battle/cancel_box.png"))
        cancel.scale = 4
        cancel.pos = (36, 580)

        val cancel_msg = Text(font)
        cancel_msg.msg = "Retour au combat"
        cancel_msg.pos = (300, 660)

        this.addComponent(cancel)
        this.addComponent(cancel_msg)
