package SFML.Wrapper
package Graphics

import scalanative.unsafe.*

import System.Vector2i

class IntRect(val left: Int, val top: Int, val width: Int, val height: Int) extends SFMLBind[SFML.Bindings.Graphics.Rect.sfIntRect]:
    import SFML.Bindings.Graphics.Rect.*

    def this() =
        this(0, 0, 0, 0)

    def this(origin: Vector2i, size: Vector2i) =
        this(origin.x, origin.y, size.x, size.y)

    def bind(implicit z: Zone) =
        val intRect = alloc[sfIntRect]()

        intRect._1 = left
        intRect._2 = top
        intRect._3 = width
        intRect._4 = height
        return intRect

    def contains(x: Int, y: Int): Boolean =
        Zone { implicit z => sfIntRect_contains(bind(z), x, y) == SFML.Bindings.Type.sfTrue }
