package SFML.Wrapper
package Graphics

import scalanative.unsafe.*

class Sprite() extends SFMLBind[SFML.Bindings.Graphics.Sprite.sfSprite]:
    import SFML.Bindings.Graphics.Sprite.*

    private var sprite: Ptr[sfSprite] = sfSprite_create()

    def bind(implicit z: Zone) = sprite

    def this(texture: Texture) =
        this()
        setTexture(texture, true)

    def destroy(): Unit =
        sfSprite_destroy(sprite)
        sprite = null

    def setColor(color: Graphics.Color): Unit =
        Zone { implicit z => sfSprite_setColor(sprite, color.bind(z)) }

    def setPosition(position: System.Vector2f): Unit =
        Zone { implicit z => sfSprite_setPosition(sprite, position.bind(z)) }

    def setScale(scale: System.Vector2f): Unit =
        Zone { implicit z => sfSprite_setScale(sprite, scale.bind(z)) }

    def setTexture(texture: Texture, resetRect: Boolean): Unit =
        val sfResetRect = if resetRect then SFML.Bindings.Type.sfTrue else SFML.Bindings.Type.sfFalse
        Zone { implicit z => sfSprite_setTexture(sprite, texture.bind(z), sfResetRect) }

    def setTextureRect(rectangle: IntRect): Unit =
        Zone { implicit z => sfSprite_setTextureRect(sprite, rectangle.bind(z)) }
