package SFML.Wrapper
package Graphics

import scalanative.unsafe.*
import scalanative.unsigned.UnsignedRichInt

class Text() extends SFMLBind[SFML.Bindings.Graphics.Text.sfText]:
    import SFML.Bindings.Graphics.Text.*

    private var text: Ptr[sfText] = sfText_create()

    def bind(implicit z: Zone) = text

    def getGlobalBounds(): FloatRect =
        Zone { implicit z =>
            val rect = alloc[SFML.Bindings.Graphics.Rect.sfFloatRect]()

            sfText_getGlobalBounds(text, rect)
            FloatRect(rect._1, rect._2, rect._3, rect._4)
        }

    def setCharacterSize(size: Int): Unit =
        sfText_setCharacterSize(text, size.toUInt)

    def setColor(color: Color): Unit =
        Zone { implicit z => sfText_setColor(text, color.bind(z)) }

    def setFont(font: Font): Unit =
        Zone { implicit z => sfText_setFont(text, font.bind(z)) }

    def setPosition(position: System.Vector2f): Unit =
        Zone { implicit z => sfText_setPosition(text, position.bind(z)) }

    def setString(string: String): Unit =
        Zone { implicit z => sfText_setString(text, toCString(string)) }
