package SFML.Wrapper
package System

import scalanative.unsafe.*

implicit def tupleToVectorInt(tuple: (Int, Int)): Vector2i =
    return Vector2i(tuple._1, tuple._2)

class Vector2i(val x: Int, val y: Int) extends SFMLBind[SFML.Bindings.System.Vector2.sfVector2i]:
    import SFML.Bindings.System.Vector2.*

    def bind(implicit z: Zone) =
        val vector2i = alloc[sfVector2i]()

        vector2i._1 = x
        vector2i._2 = y
        return (vector2i)

    def +(rhs: Vector2i) =
        Vector2i(x + rhs.x, y + rhs.y)

    def *(rhs: Vector2i) =
        Vector2i(x * rhs.x, y * rhs.y)

    def *(rhs: Float) =
        Vector2i((x * rhs).toInt, (y * rhs).toInt)
